﻿/*
 * ROT.c
 *
 * Created: 20/9/2016 8:10:59 pm
 *  Author: Dimitrios Porlidas
 */ 

#include "LCD_keyb_ROT.h"

ISR(INT0_vect)												// Interrupt INT0, PD2 RotA, CW Increase, start moving rotor (A->0, B=1)
{
//	sei();													// Enable interrupts (if necessary)
//	cli();													// Disable interrupts (if necessary)
	_delay_ms(1);
	while (!(bit_is_set(PIND,2)));							// A=0
	_delay_ms(1);
	if ((bit_is_set(PIND,2)) && (!(bit_is_set(PIND,3))))	// Rotor moving (A=1, B=0)
	{
		if (reg1bin <= 0xF0)
		reg1bin = reg1bin + 0xF;							// Increase
		OCR0 = reg1bin;
	}
	
	while (!(bit_is_set(PIND,3)));							// B=0
	_delay_ms(1);
	CountROT ();
}

ISR(INT1_vect)												// Interrupt INT1, PD3 RotB, CCW Decrease, start moving rotor (B->0, A=1)
{
//	sei();													// Enable interrupts (if necessary)
//	cli();													// Disable interrupts (if necessary)
	_delay_ms(1);
	while (!(bit_is_set(PIND,3)));							// B=0
	_delay_ms(1);
	if ((bit_is_set(PIND,3)) && (!(bit_is_set(PIND,2))))	// Rotor moving (B=1, A=0)
	{
		if (reg1bin >= 0xF)
		reg1bin = reg1bin - 0xF;							// Decrease
		OCR0 = reg1bin;
	}
	while (!(bit_is_set(PIND,2)));							// A=0
	_delay_ms(1);
	CountROT ();
}

void InitROT (void)											// Start up, initialization rutine
{
	MCUCR |= (1<<ISC01);									// Interrupt by the falling edge INT0
	MCUCR |= (1<<ISC11);									// Interrupt by the falling edge INT1
	GICR |= (3<<6);											// Enable INT0, INT1 interrupt
	sei();													// Enable interrupts
//	cli();													// Disable interrupts
	DDRD &= ~((1<<2)|(1<<3));								// Port PD2, PD3 inputs
	PORTD |= (3<<PORTD2);									// Port PD2, PD3 Enable pull up
}

void CountROT (void)
{
	itoa (reg1bin, reg1asc, 10);							// Counter, Transform binary integer to decimal ASCII string
	SeCu (L1R1);											// Send cursor to a specific address 0-80 (LCD)
	_delay_ms (5);
	for (uint8_t irot = 0; irot < (unsigned)strlen(reg1asc); irot++)	// Send ASCII string to LCD
	WrDa (reg1asc[irot]);									//
	WrDa('A');												// Write A at the end of number
	for (uint8_t irot = (unsigned)strlen(reg1asc); irot < 7; irot++)	// Complete with blanks
	WrDa(' ');
}