﻿/*
 * keyb.c
 *
 * Created: 20/09/2016 1:35:06 am
 * Author:	Dimitrios Porlidas
 */ 

#include "LCD_keyb_ROT.h"

void Initkeyb (void)
{
	keyddr = 0b00001111;									// Keyboard PORTx4:7 inputs (columns), PORTx0:3 outputs (rows)
	keyport = 0b11111111;									// Enable pull up resistors on inputs, send 1 to outputs (keyboard)
}

void Keyb (void)											// Keyboard routine
{
	line = 1;												// Prepare register to scan lines 
	for (ln1 = 0; ln1 < 4; ln1++)							// Scan lines loop
	{
		keyport = ~line;									// Scan line
		line = line << 1;									// Shift register to prepare next line 
		while (keyreg < 0b11101111)							// If any button pressed enter subroutine
		{
			_delay_ms (5);									// Delay to ignore switch noise
			switch (keyreg)									// Matching button subroutine
			{
				case 0b11101110:							// Button 1 pressed 
				data = '1';
				entry |= (1<<0);							// Set entry flag
				while (keyreg == 0b11101110);				// Wait if button is still pressed
				break;

				case 0b11101101:							// Button 4 pressed
				data = '4';
				entry |= (1<<0);							// Set entry flag
				while (keyreg == 0b11101101);				// Wait if button is still pressed
				break;

				case 0b11101011:							// Button 7 pressed
				data = '7';
				entry |= (1<<0);							// Set entry flag
				while (keyreg == 0b11101011);				// Wait if button is still pressed
				break;

				case 0b11100111:							// Button * pressed
				data = '*';
				entry |= (1<<0);       // Set entry flag
				while (keyreg == 0b11100111);				// Wait if button is still pressed
				break;

				case 0b11011110:							// Button 2 pressed
				data = '2';
				entry |= (1<<0);							// Set entry flag
				while (keyreg == 0b11011110);				// Wait if button is still pressed
				break;

				case 0b11011101:							// Button 5 pressed
				data = '5';
				entry |= (1<<0);							// Set entry flag
				while (keyreg == 0b11011101);				// Wait if button is still pressed
				break;

				case 0b11011011:							// Button 8 pressed
				data = '8';
				entry |= (1<<0);							// Set entry flag
				while (keyreg == 0b11011011);				// Wait if button is still pressed
				break;

				case 0b11010111:							// Button 0 pressed
				data = '0';
				entry |= (1<<0);							// Set entry flag
				while (keyreg == 0b11010111);				// Wait if button is still pressed
				break;

				case 0b10111110:							// Button 3 pressed
				data = '3';
				entry |= (1<<0);							// Set entry flag
				while (keyreg == 0b10111110);				// Wait if button is still pressed
				break;

				case 0b10111101:							// Button 6 pressed
				data = '6';
				entry |= (1<<0);							// Set entry flag
				while (keyreg == 0b10111101);				// Wait if button is still pressed
				break;

				case 0b10111011:							// Button 9 pressed
				data = '9';
				entry |= (1<<0);							// Set entry flag
				while (keyreg == 0b10111011);				// Wait if button is still pressed
				break;

				case 0b10110111:							// Button # pressed
				data = '#';
				entry |= (1<<0);							// Set entry flag
				while (keyreg == 0b10110111);				// Wait if button is still pressed
				break;

				case 0b01111110:							// Button A pressed
				data = 'A';
				entry |= (1<<0);							// Set entry flag
				while (keyreg == 0b01111110);				// Wait if button is still pressed
				break;

				case 0b01111101:							//Button B pressed
				data = 'B';
				entry |= (1<<0);							// Set entry flag
				while (keyreg == 0b01111101);				// Wait if button is still pressed
				break;

				case 0b01111011:							// Button C pressed
				data = 'C';
				entry |= (1<<0);							// Set entry flag
				while (keyreg == 0b01111011);				// Wait if button is still pressed
				break;

				case 0b01110111:							// Button D pressed
				data = 'D';
				entry |= (1<<0);							// Set entry flag
				while (keyreg == 0b01110111);				// Wait if button is still pressed
				break;
			}
		}
	}
}
